<?

 /*****************************************************************************
 * Filename: include.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 if(!ini_get("date.timezone"))
  date_default_timezone_set("UTC");

 if(!isset($_benchmark))
  $_benchmark=false;

//pretty urls
 if(!isset($_SERVER["REQUEST_FIXED"])) //already fixed the request?
 {
  $_SERVER["REQUEST_FIXED"]=true; //ensure pretty urls check is only done once
  if(isset($_SERVER["REQUEST_URI"])&&($url=explode("?", $_SERVER["REQUEST_URI"], 2))) //get url path
  {
   if(!file_exists($_SERVER["DOCUMENT_ROOT"].$url[0])) //pretty url (i.e. directory doesn't exist)
   {
    //find nearest existing parent file or directory with index.php
    $vars=Array();
    $url=rtrim($url[0], "/");
    while(true)
    {
     if(file_exists($_SERVER["DOCUMENT_ROOT"].$url)) //existing path
     {
      if(is_dir($_SERVER["DOCUMENT_ROOT"].$url)) //directory
      {
       if(file_exists($_SERVER["DOCUMENT_ROOT"].$url."/index.php")) //directory index
       {
        $url.="/index.php";
        break;
       }
      }
      else //file
       break;
     }

     if(($pos=strrpos($url, "/"))!==false)
     {
      $vars[]=substr($url, $pos+1);
      $url=substr($url, 0, $pos);
     }
     else //no more slashes
      break;
    }

    if($vars)
     $vars=array_reverse($vars);

    if($vars) //set vars
     $_REQUEST["p"]=$_GET["p"]=$vars;

    if($url!=$_SERVER["SCRIPT_NAME"]) //script name differs, call new script name
    {
     //overwrite _SERVER vars
     $_SERVER["SCRIPT_NAME"]=$_SERVER["PHP_SELF"]=$url;
     $_SERVER["SCRIPT_FILENAME"]=$_SERVER["DOCUMENT_ROOT"].$url;

     //clean up
     unset($_project, $_jseskey, $_path);
     unset($url, $vars);

     chdir(dirname($_SERVER["SCRIPT_FILENAME"]));
     require($_SERVER["SCRIPT_FILENAME"]);
     exit; //done
    }
    //else same script name, continue execution
   }

   //clean up
   unset($url, $vars);
  }
 }

//set basic path
 if(!isset($_path)||!isset($_path["root"]))
  $_path["root"]="";
 if(!isset($_path["include"]))
  $_path["include"]=$_path["root"]."include/";

//init session
 require_once($_path["include"]."session.php");

//detect project
 if(!$_session->get("project"))
 {
  if(isset($_project)&&$_project&&preg_match("/^([a-z0-9]{1,25})$/i", $_project)) //$_project?
  {
   $_session->set("project", $_project);
   unset($_project);
  }
  else if(preg_match("!project/([a-z0-9]{1,25})/!i", $_SERVER["SCRIPT_FILENAME"], $tmp)) //project dir in script filename?
   $_session->set("project", $tmp[1]);
  else if(isset($_SERVER["PWD"])&&preg_match("!project/([a-z0-9]{1,25})/!i", $_SERVER["PWD"], $tmp)) //cli: maybe in current path?
   $_session->set("project", $tmp[1]);
  else
   $_session->set("project", "jas");
 }

//setup path
 require($_path["include"]."path.php");

//load config
 require_once($_path["include"]."config.php");
 $_config->load();

//send basic headers
 require_once($_path["include"]."headers.php");
 Headers::basicS();

//php configuration, read after config
 require($_path["include"]."php.ini.php");

//browser and os detection
 require($_path["include"]."browser.php");

//setup _benchmark
 if($_config->get("benchmark")&&!$_benchmark)
 {
  require_once($_path["include"]."benchmark.php");
  $_benchmark=new Benchmark();
 }

//detect current project from JAS sites config
 if($_session->get("project")==$_session->backendKey()&&$_session->getKey()!=$_session->backendKey()&&($sites=$_config->get("sites")))
 {
  $found=false;
  foreach($sites as $domain => $project) //find matching domain
  {
   if($domain&&$domain==$_SERVER["HTTP_HOST"])
   {
    $found=$project;
    break;
   }
  }

  if(!$found) //no matching domain
   if(isset($sites[""])) //use default project
    $found=$sites[""];

  if(!$found||$_session->get("project")==$found) //current project (jas) already active
   $_config->set("sites"); //don't keep trying to detect current site
  else
  {
   $_session->set("project", $found); //overwrite project variable
   $_config->set(false); //clear config (including user/groups)

   unset($_path["project"]); //clear project path definition
   require($_path["root"]."include.php"); //init basics
  }

  unset($found, $sites, $domain, $project);
 }
?>
