<?

 /*****************************************************************************
 * Filename: include/browser.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 if(!$_session->get("browser"))
 {
  if(isset($_SERVER["HTTP_USER_AGENT"]))
  {

/* OS detection */

   if(strstr($_SERVER["HTTP_USER_AGENT"], "Android"))
    $_session->set("os", "Android");
   else if(preg_match("/(Linux|FreeBSD|NetBSD)/i", $_SERVER["HTTP_USER_AGENT"], $tmp))
    $_session->set("os", $tmp[1]);
   else if(preg_match("/Windows\s(3\.1|95|NT|98|ME|2000|XP|2003)/i", $_SERVER["HTTP_USER_AGENT"], $tmp))
   {
    if($tmp[1]=="98"&&preg_match("/Win 9x 4\.9/", $_SERVER["HTTP_USER_AGENT"]))
     $_session->set("os", "Windows ME");
    else if($tmp[1]=="NT"&&preg_match("/Windows NT 5\.1/", $_SERVER["HTTP_USER_AGENT"]))
     $_session->set("os", "Windows XP");
    else
     $_session->set("os", "Windows ".$tmp[1]);
   }
   else
    $_session->set("os", "unknown");

 /* Browser Detection */

   if(preg_match("/Opera.*Version\/([0-9]+)\.([0-9]*)/i", $_SERVER["HTTP_USER_AGENT"], $tmp))
   {
    $_session->set("browser", "Opera ".$tmp[1].".".$tmp[2]);
    $_session->set("stylesheet", "opera".$tmp[1]);
   }
   else if(preg_match("/Opera(\s|\/)([0-9]+)\.{0,1}([0-9]*)/i", $_SERVER["HTTP_USER_AGENT"], $tmp))
   {
    $_session->set("browser", "Opera ".$tmp[2].".".$tmp[3]);
    $_session->set("stylesheet", "opera".$tmp[2]);
   }
   else if(preg_match("/Opera/i", $_SERVER["HTTP_USER_AGENT"], $tmp))
   {
    $_session->set("browser", "Opera");
    $_session->set("stylesheet", "opera");
   }
   else if(preg_match("/Otter(\s|\/)([0-9]+)\.{0,1}([0-9]*)/i", $_SERVER["HTTP_USER_AGENT"], $tmp))
   {
    $_session->set("browser", "Otter ".$tmp[2].".".$tmp[3]);
    $_session->set("stylesheet", "otter".$tmp[2]);
   }
   else if(preg_match("/Chrome(\s|\/)([0-9]+)\.{0,1}([0-9]*)/i", $_SERVER["HTTP_USER_AGENT"], $tmp))
   {
    $_session->set("browser", "Chrome ".$tmp[2].".".$tmp[3]);
    $_session->set("stylesheet", "chrome".$tmp[2]);
   }
   else if(preg_match("/MSIE\s([0-9]+)\.{0,1}([0-9]*)/i", $_SERVER["HTTP_USER_AGENT"], $tmp))
   {
    $_session->set("browser", "Internet Explorer ".$tmp[1].".".$tmp[2]);
    $_session->set("stylesheet", "ie".$tmp[1]);
   }
   else if(preg_match("/Netscape\/{0,1}([0-9]+)\.{0,1}([0-9]*)/i", $_SERVER["HTTP_USER_AGENT"], $tmp))
   {
    $_session->set("browser", "Netscape ".$tmp[1].".".$tmp[2]);
    $_session->set("stylesheet", "netscape".$tmp[1]);
   }
   else if(preg_match("/Mozilla\/(4)/i", $_SERVER["HTTP_USER_AGENT"], $tmp))
   {
    $_session->set("browser", "Netscape ".$tmp[1]);
    $_session->set("stylesheet", "netscape".$tmp[1]);
   }
   else if(preg_match("/Konqueror\/([0-9]+)\.{0,1}([0-9]*)/i", $_SERVER["HTTP_USER_AGENT"], $tmp))
   {
    $_session->set("browser", "Konqueror ".$tmp[1].".".$tmp[2]);
    $_session->set("stylesheet", "konqueror".$tmp[1]);
   }
   else if(preg_match("/Konqueror/i", $_SERVER["HTTP_USER_AGENT"], $tmp))
   {
    $_session->set("browser", "Konqueror");
    $_session->set("stylesheet", "konqueror");
   }
   else if(preg_match("/SeaMonkey\/([0-9]+)\.{0,1}([0-9]*)/i", $_SERVER["HTTP_USER_AGENT"], $tmp))
   {
    $_session->set("browser", "SeaMonkey ".$tmp[1].".".$tmp[2]);
    $_session->set("stylesheet", "seamonkey".$tmp[1]);
   }
   else if(preg_match("/Firefox\/([0-9]+)\.{0,1}([0-9]*)/i", $_SERVER["HTTP_USER_AGENT"], $tmp))
   {
    $_session->set("browser", "Firefox ".$tmp[1].".".$tmp[2]);
    $_session->set("stylesheet", "firefox".$tmp[1]);
   }
   else if(preg_match("/Mozilla\/([0-9]+)\.{0,1}([0-9]*)/i", $_SERVER["HTTP_USER_AGENT"], $tmp))
   {
    $_session->set("browser", "Mozilla ".$tmp[1].".".$tmp[2]);
    $_session->set("stylesheet", "mozilla".$tmp[1]);
   }
   else if(preg_match("/Lynx\/([0-9]+)\.{0,1}([0-9]*)/i", $_SERVER["HTTP_USER_AGENT"], $tmp))
   {
    $_session->set("browser", "Lynx ".$tmp[1].".".$tmp[2]);
    $_session->set("stylesheet", "text");
   }
   else if(preg_match("/Links \(([0-9]+)\.{0,1}([0-9]*)/i", $_SERVER["HTTP_USER_AGENT"], $tmp))
   {
    $_session->set("browser", "Links ".$tmp[1].".".$tmp[2]);
    $_session->set("stylesheet", "text");
   }
   else
   {
    $_session->set("browser", $_SERVER["HTTP_USER_AGENT"]);
    $_session->set("stylesheet", "unknown");
   }
   unset($tmp);
  }
  else
  {
   $_session->set("os", "unknown");
   $_session->set("browser", "useragent not set");
   $_session->set("stylesheet", "unknown");
  }
 }
?>
