<?

 /*****************************************************************************
 * Filename: include/modules/configFilter.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["include"]."module.php");
 require_once($_path["modules"]."config.php");

 class System_Module_configFilter extends Module
 {
  function __construct(&$data)
  {
   parent::__construct($data);

   $this->data->title="Filter configuration";

   $this->data->defaultFields("id;added;updated");
   $this->data->setShowFields(); //clear show fields

   $this->data->addField("userrights", "rights", "", "allusers", 0, false, 256); //view rights for all
   $this->data->addField("faketitle", "text", "show", "title;hidden", 0, false, $this->data->title, "Title");

   $this->data->addField("showTimezone", "boolean", "all", false, false, false, false, "Show timezone", "Shows timezone information for datetime fields");
   $this->data->addField("showDateformat", "boolean", "all", false, false, false, false, "Show date/time format", "Shows date/time format for date/time/datetime fields");

   $this->data->addField("showErrors", "boolean", "all", false, false, false, true, "Show errors", "Show errors generated by submitting information");
   $this->data->addField("showFields", "boolean", "all", false, false, false, true, "Show field", "If you want to be able to input something leave this enabled");
   $this->data->addField("showGroups", "boolean", "all", false, false, false, true, "Show groups", "Group fields together");
   $this->data->addField("showSubmit", "boolean", "all", false, false, false, true, "Show submit", "Shows submit button");
   $this->data->addField("showReset", "boolean", "all", false, false, false, true, "Show reset", "Shows reset button");

   $this->data->addField("useStyling", "boolean", "all", "reload", false, false, true, "Use styling", "Use HTML styling");
   $this->data->addField("defaultFormVars", "text", "all", false, 0, 255, false, "Default form variables", "eg: cms=1&title=asd&");
   $this->data->addField("anchoring", "boolean", "all", false, false, false, 1, "Add field anchors", "Reload field property jumps to anchor");

   $this->data->group("Show", "showTimezone", "showDateformat", "showErrors", "showFields", "showGroups", "showSubmit", "showReset", "useStyling");
  }

  function viewPostGet()
  {
   for($c=0;$c<$this->data->vmax;$c++)
    $this->data->setValue("faketitle", $this->data->title, $c);

   return true;
  }


  function addPostSubmit(){return System_Module_config::updateConfig();}
  function editPostSubmit(){return System_Module_config::updateConfig();}
  function deletePostSubmit(){return System_Module_config::updateConfig();}
 }

?>
