<?

 /*****************************************************************************
 * Filename: include/plugins/unit_testing/ut/storage.pgsql.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["plugins"]."unit_testing/ut/storage.sql.php");
 require_once($_path["include"]."storage/pgsql.php");
 require_once($_path["include"]."data.php");

 class UT_Storage_PGSQL extends UT_Storage_SQL
 {
  function Constructor()
  {
   $d=new Data();
   $object=new System_Storage_pgsql($d, false);

   if(!is_object($object)||get_class($object)!="System_Storage_pgsql")
   {
    $this->e->add("Constructor doesn't return a System_Storage_pgsql object", "error");
    return UT_FAILED;
   }

   if(!is_object($object->e)||get_class($object->e)!="Errors")
   {
    $this->e->add("Object: \"e\" isn't an Errors object", "error");
    return UT_FAILED;
   }

   if($object->engine!==false)
   {
    $this->e->add("Variable: \"engine\" isn't false", "error");
    return UT_FAILED;
   }
   if($object->collation!=="en_US.utf8")
   {
    $this->e->add("Variable: \"collation\" isn't en_US.utf8", "error");
    return UT_FAILED;
   }
   if($object->charset!=="UTF8")
   {
    $this->e->add("Variable: \"charset\" isn't UTF8", "error");
    return UT_FAILED;
   }
   if($object->enum_type!==false)
   {
    $this->e->add("Variable: \"enum_type\" isn't false", "error");
    return UT_FAILED;
   }

   if($object->qv!=="'")
   {
    $this->e->add("Variable: \"value quotes\" isn't a '", "error");
    return UT_FAILED;
   }
   if($object->qt!=="\"")
   {
    $this->e->add("Variable: \"table quotes\" isn't a \"", "error");
    return UT_FAILED;
   }
   if($object->qf!=="\"")
   {
    $this->e->add("Variable: \"field quotes\" isn't a \"", "error");
    return UT_FAILED;
   }
   if($object->qi!=="\"")
   {
    $this->e->add("Variable: \"index quotes\" isn't a \"", "error");
    return UT_FAILED;
   }

   if(!is_array($object->crossConvert))
   {
    $this->e->add("Variable: \"crossConvert\" isn't an array", "error");
    return UT_FAILED;
   }
   if(!isset($object->crossConvert["int"]))
   {
    $this->e->add("Variable: \"crossConvert\" doesn't have an entry: int", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }
 }

?>
