<?

 /*****************************************************************************
 * Filename: include/stp.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["include"]."language.php");
 require_once($_path["include"]."errors.php");

 global $_stp_first;
 $_stp_first=true;

 class STP
 {
  function __construct()
  {
   global $_session, $_stp_first;

   $this->e=new Errors();
   $this->e->l->read("stp");

   $this->name="_stp";
   $this->maxTokens=10;

   $_session->setGlobal();
   $this->tokens=&$_session->getReference("stp.tokens");

   if(!is_array($this->tokens))
    $_session->set("stp.tokens", Array());

   $_session->setCurrent();

   if($_stp_first) //first load on current page
   {
    $_stp_first=false;

    $this->newToken();
    register_shutdown_function(Array($this, "cleanUp"));
   }
   else if(!$this->tokens)
    $this->newToken();
  }

  function __clone()
  {
   //clone objects
   $this->e=clone $this->e;
  }


  /*
   * Generate
   */

  function generate()
  {
   $token=rand();
   $token*=rand();

   return strtoupper(md5($token));
  }

  function newToken()
  {
   while($token=$this->generate()) //generate a new token
   {
    if(!isset($this->tokens[$token])) //check if token already exist
    {
     $this->tokens[$token]=false; //new unused token
     break;
    }
   }

   return $token;
  }


  /*
   * Name
   */

  function getName()
  {
   return $this->name;
  }


  /*
   * Current
   */

  function getCurrent()
  {
   if(!$this->tokens)
    return false;

   $tokens=array_keys($this->tokens);
   return end($tokens);
  }

  function getCurrentURL()
  {
   return $this->name."=".$this->getCurrent();
  }

  function getCurrentInput()
  {
   return "<input type=\"hidden\" name=\"".$this->name."\" value=\"".$this->getCurrent()."\"/>";
  }

  function updateCurrent($text)
  {
   return preg_replace(Array("/(".$this->name.")=[0-F]{32}/", "/(name=\"".$this->name."\" value)=\"[0-F]{32}\"/"), Array("\\1=".$this->getCurrent(), "\\1=\"".$this->getCurrent()."\""), $text);
  }

  /*
   * Validate
   */

  function check($token=false)
  {
   if(!$token)
    $token=request($this->name);

   if(!$token)
   {
    $this->e->add("No token provided", "error");
    return false;
   }

   if(!isset($this->tokens[$token]))
   {
    $this->e->add("Unknown token: \"".$token."\"", "error");
    return false;
   }

   if($token!=$this->getCurrent())
    $this->tokens[$token]=true; //mark as used (removed at end of page load)

   return true;
  }


  /*
   * Clean up
   */

  function cleanUp()
  {
   //remove used tokens
   foreach($this->tokens as $token => $used)
    if($used)
     unset($this->tokens[$token]);

   //remove old tokens
   if(sizeof($this->tokens)>$this->maxTokens)
   {
    $tokens=array_keys($this->tokens); //get oldest tokens (at front of the array)
    $tokens=array_slice($tokens, 0, -$this->maxTokens);

    foreach($tokens as $token)
     unset($this->tokens[$token]);
   }

   return true;
  }
 }

?>
