<?

 /*****************************************************************************
 * Filename: project/jas/include/backend/projects.config.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["project"]["include"]."backend/base.php");
 require_once($_path["include"]."cms.php");
 require_once($_path["include"]."jas.php");

 class Backend_Projects_Config extends Backend_Base
 {
  function __construct(&$backend)
  {
   parent::__construct($backend);

   $this->data=false;
   $this->jasRootUser=false;
  }


  function data()
  {
   global $_session, $_config;

   $this->data=Data::cache("config", "view", "all");
   $this->data->clearValues();
   $this->data->setValue("show_total", 1);

   $_session->frontend();

   if(!$this->data->get()||!$this->data->vmax)
   {
    $this->data->setAction("add");

    foreach($this->data->check("use", "form") as $field)
     $this->data->setDefaultValue($field);

    $this->data->setValue("title", $_config->get("title"));
   }
   else
    $this->data->setAction("edit");

   $this->data->setExtra("item");

   $_session->backend();
  }


  function status(&$text)
  {
   $this->data();

   if(!$this->data->next())
   {
    $text="Project configuration not setup";
    return "Failure";
   }

   $text="";
   return "Done";
  }

  function main($submit=true)
  {
   global $_session, $_config;

   $this->jasRootUser=$_config->userRoot(); //get jas project user root status

   if(!$this->jasRootUser)
   {
    $this->e->add("Project configuration can only be setup by the JAS root user", "error");
    return false;
   }

   $this->data();

   $_session->frontend();

   if(request("s")&&$submit)
   {
    if($this->stp&&!$this->stp->check())
    {
     $this->e->add("STP doesn't match", "error");
     $_session->backend();
     return false;
    }

    $this->data->setRequestValues();

    if($this->data->check("type", "stp", "_stp")) //disable STP check (done in project.php based on JAS project config)
     unset($this->data->field["_stp"]);

    $_config->su(true);
    if($this->data->submit())
    {
     $_config->su();
     $this->e->add("Project: \"".$_session->get("project")."\" successfully configured", "note");
     $_config->reload();
     $_session->backend();
     return "next";
    }
    else
    {
     $_config->su();
     $this->e->add($this->data->e);
     $_session->backend();
     return false;
    }
   }

   $_session->backend();
   return true;
  }


  /*
   * Output
   */

  function output()
  {
   if(!$this->jasRootUser)
    return "&nbsp; ";


   $cms=new CMS();
   $cms->setDataForm($this->data, $this->form);

   $_POST["dontgetdata"]=true; //ensure data isn't gathered again

   $form=$cms->formShowFields();
   $form.=$this->confirm(Array("history", (!$this->jasRootUser?"disabled":false)));

   $r=$this->form($form, $this->url("projects/setup/config/"));

   return $r;
  }

 }
?>
