<?

 /*****************************************************************************
 * Filename: project/jas/include/modules/configSites.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["include"]."module.php");
 require_once($_path["modules"]."config.php");

 class JAS_Module_configSites extends Module
 {
  function __construct(&$data)
  {
   global $_config;

   parent::__construct($data);

   $this->data->title="Sites configuration";

   $this->data->defaultFields("id;added;updated");

   $this->data->setShowFields(); //clear show fields

   $this->data->addField("userrights", "rights", "", "allusers", 0, false, 256); //view rights for all

   $this->data->addField("domain", "domain", "all", "title", 0, 50, "", "Domain name", "Leave empty for default site");
   $this->data->addField("project", "project", "all", "title", 1, 25, false, "Project", "Which project should this site start");

   $this->data->addUnique("domain", "domain");
   $this->data->sortOrder("domain");
  }


  function addPostSubmit(){return System_Module_config::updateConfig();}
  function editPostSubmit(){return System_Module_config::updateConfig();}
  function deletePostSubmit(){return System_Module_config::updateConfig();}
 }

?>
