<?

 /*************************************************************************************
 * Filename: setup.php
 *
 * This file is part of the Skeleton JAS plugin.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The Skeleton JAS plugin is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the plugin or http://jas.junerules.com/plugins/skeleton/
 *************************************************************************************/


 class Plugin_Setup_skeleton extends Base_Plugin_Setup
 {
  function init()
  {
   global $_path;

   $this->modules(); //make sure all skeleton module tables created

   $this->mkdir($_path["project"]["style"]); //create a directory

   $this->file("setup/skeleton.css", $_path["project"]["style"]); //copy a file

   $this->data("categories", "name", Array( //create category for pluginConfigs
    "name" => "Skeleton",
    "moduleLock" => true,
    "module" => Array("skeleton_pluginConfigs"),
   ));

   $this->data("skeleton_pluginConfigs", Array("plugin", "key"), Array(
    Array(
     "catnr" => (object) Array("set" => 0, "entry" => 0, "field" => "nr"), //use nr value from first entry in first data set
     "plugin" => "skeleton",
     "key" => "First key",
    ),
    Array(
     "catnr" => (object) Array("set" => 0, "entry" => 0, "field" => "nr"), //use nr value from first entry in first data set
     "plugin" => "skeleton",
     "key" => "Second key",
    ),
   ));


   return true;
  }

  function preSetup()
  {
   global $_path;

   $skeletonConf="\n ".'$db["skeleton"]="skeleton_example://";'."\n";

   $conf=false;
   if(file_exists($_path["project"]["include"]."db.conf.php"))
   {
    if(!($conf=@file_get_contents($_path["project"]["include"]."db.conf.php")))
    {
     $this->e->add("Unable to read db.conf.php, please add \"".$skeletonConf."\" manualy", "warning");
     return true;
    }
   }

   if($conf)
   {
    if(strstr($conf, '$db["skeleton"]="skeleton_example://"'))
    {
     $this->e->add("Skeleton DB already in db.conf.php", "note");
     return true;
    }
    else
     $conf=preg_replace("/\?\>/", $skeletonConf."?>", $conf);
   }
   else
    $conf="<?".$skeletonConf."?>";

   if(!(@file_put_contents($_path["project"]["include"]."db.conf.php", $conf)))
   {
    $this->e->add("Unable to write db.conf.php, please add \"".$skeletonConf."\" manualy", "warning");
    return true;
   }

   return true;
  }

  function postSetup()
  {
   return true;
  }

  function preDeSetup()
  {
   return true;
  }

  function postDeSetup()
  {
   return true;
  }

 }
?>
