

 /*****************************************************************************
 * Filename: project/jas/script/gui.js
 *
 * This file is part of the JAS project.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


if(typeof(onload)!='function')
 alert("Script not loaded: functions.js");
else if(typeof(setGetElementFunctions)!="function")
 alert("Script not loaded: getelements.js");
else
 onload("initCheckall();");

function initCheckall()
{
 var checkall=document.getElementsByClassName("checkall");

 for(var c=0;c<checkall.length;c++)
 {
  //find parent table
  var table=checkall[c].parentNode;
  while(table.tagName.toLowerCase()!="table")
  {
   if(typeof(table.parentNode)=="undefined")
   {
    table=false;
    break;
   }

   table=table.parentNode;
  }

  if(!table) //not in table
   return false;

  //get checkboxes and add row check
  var checkboxes=Array();
  var input=table.getElementsByTagName("input");
  for(var x=0;x<input.length;x++)
  {
   if(input[x].type.toLowerCase()=="checkbox")
   {
    checkboxes.push(input[x]);

    //find parent row
    var tmp=input[x];
    while(tmp.parentNode)
    {
     tmp=tmp.parentNode;
     
     if(tmp.tagName.toLowerCase()=="tr") //row
     {
      //add check to all columns except checkbox column
      var cols=tmp.getElementsByTagName("td");
      for(var z=0;z<cols.length;z++)
      {
       if(cols[z].getElementsByTagName("input").length) //columns has input element
        continue; //skip

       cols[z].checkbox=input[x];
       cols[z].onclick=rowCheck;
      }
      break;
     }
    }
   }
  }

  if(!checkboxes.length)
   return false;

  //create checkbox
  var checkbox=document.createElement("input");
  checkbox.type="checkbox";

  checkbox.setAttribute("class", checkboxes[0].getAttribute("class"));
  checkbox.setAttribute("style", checkboxes[0].getAttribute("style"));

  checkbox.checkboxes=checkboxes;
  checkbox.onchange=setCheck;

  checkall[c].appendChild(checkbox);
 }

 return true;
}

function setCheck(e)
{
 for(var c=0;c<this.checkboxes.length;c++)
  this.checkboxes[c].checked=!this.checkboxes[c].checked;

 return true;
}

function rowCheck(e)
{
 if(typeof(this.checkbox)!="undefined")
  this.checkbox.checked=!this.checkbox.checked;

 return true;
}
