

 /*****************************************************************************
 * Filename: script/getelements.js
 *
 * This file is part of the JAS project.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


function getAllElements()
{
 return this.getElementsByTagName("*");
}

function getElementsByClassName(className)
{
 var x=0;
 var elements=Array();
 var all=this.getAllElements();
 var regexp=new RegExp("(^| )"+className+"( |$)");

 for(var c=0;c<all.length;c++)
  if(all[c].className!=undefined&&all[c].className)
   if(regexp.test(all[c].className))
    elements[x++]=all[c];

 return elements;
}

function setGetElementFunctions()
{
 //This should be done using prototypes however Firefox blocks overriding (these) native functions.
 //As a result setGetElementFunctions must be called after new elements are created dynamically.
 document.getAllElements=getAllElements;
 document.getElementsByClassName=getElementsByClassName;

 var all=document.getAllElements();
 for(var c=0;c<all.length;c++)
 {
  all[c].getAllElements=getAllElements;
  all[c].getElementsByClassName=getElementsByClassName;
 }
}
